std::is_literal_type(3)

NAME
std::is_literal_type - std::is_literal_type

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_literal_type; (deprecated in C++17)
                        (removed in C++20)
   (This type trait has been deprecated^[1] and removed^[2] as offering negligible
   value to generic code.)
   If T satisfies all requirements of LiteralType, provides the member constant value
   equal true. For any other type, value is false.
   The behavior is undefined if std::remove_all_extents_t<T> is an incomplete type and
   not (possibly cv-qualified) void.
   The behavior of a program that adds specializations for is_literal_type
   or is_literal_type_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_literal_type_v = (deprecated)
   is_literal_type<T>::value; (removed in C++20) Inherited from std::integral_constant

Member constants
   value true if T is a literal type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Notes
   Only literal types may be used as parameters to or returned from constexpr
   functions. Only literal classes may have constexpr member functions.

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 struct A {
     int m;
 };
 struct B {
     virtual ~B();
 };
 int main()
 {
     std::cout << std::boolalpha;
     std::cout << std::is_literal_type<A>::value << '\n';
     std::cout << std::is_literal_type<B>::value << '\n';
 }

Output:
 true
 false

External links
    1. ↑ Alisdair Meredith. "Deprecate the is_literal Trait". Deprecating Vestigial
       Library Parts in C++17. "The is_literal type trait offers negligible value to
       generic code, as what is really needed is the ability to know that a specific
       construction would produce constant initialization."
    2. ↑ Alisdair Meredith, Stephan T. Lavavej, Tomasz Kamiński. "Deprecated type
       traits". Reviewing Deprecated Facilities of C++17 for C++20. "Strong
       recommendation: Remove the traits that can live on as zombies. [...] Toronto
       Review: Accept strong recommendation, strike from C++20."